package org.openjdk.gcbench.tenure;

import org.openjdk.gcbench.tests.UnderPressureTest;
import org.openjdk.jmh.annotations.*;

import java.util.concurrent.TimeUnit;

@Warmup(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Measurement(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@Threads(Threads.MAX)
@State(Scope.Thread)
public class Arrays extends UnderPressureTest {

    Object[] tenures;

    @Param({"100000"})
    int size;

    int idx;

    @Setup
    public void setup() {
        tenures = new Object[size];
    }

    @Benchmark
    public void test() {
        int cur = idx;
        tenures[cur] = uninitAlloc(1000);
        if (cur + 1 < size) {
            idx = cur + 1;
        } else {
            idx = 0;
        }
    }

}
